<template>
  <span v-if="text && !isLoading">{{ text }}</span>
  <span
    v-else
    class="ui-text-placeholder"
    title="Loading"
  >
    &nbsp;
    <span class="uikit-opacity-0">{{ placeholderText }}</span>
  </span>
</template>

<script lang="ts">
  import { defineComponent, PropType, computed } from 'vue'

  export default defineComponent({
    name: 'ui-text-placeholder',
    props: {
      isLoading: {
        type: Boolean,
      },
      textLength: {
        type: Number,
        default: 4,
      },
      text: {
        type: [String, Object] as PropType<string | null | undefined>,
      },
    },
    setup(props) {
      const placeholderText = computed(() => '*'.repeat(props.textLength))

      return { placeholderText }
    }
  })
</script>

<style>
  .ui-text-placeholder {
    display: inline-block;
    border-radius: 4px;
    opacity: .1;
    background-color: currentColor;
    animation: pulse 2s cubic-bezier(0.4, 0, 0.6, 1) infinite;
    text-rendering: optimizeSpeed;
    user-select: none;
    pointer-events: none;
    overflow: hidden;
  }

  @keyframes pulse {
    50% {
      opacity: 0.15;
    }
  }
</style>
